package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerContractFinalSettleLostService;
import com.gxwebsoft.tower.entity.TowerContractFinalSettleLost;
import com.gxwebsoft.tower.param.TowerContractFinalSettleLostParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 结算书缺失物品控制器
 *
 * @author 科技小王子
 * @since 2023-06-18 00:52:41
 */
@Api(tags = "结算书缺失物品管理")
@RestController
@RequestMapping("/api/tower/tower-contract-final-settle-lost")
public class TowerContractFinalSettleLostController extends BaseController {
    @Resource
    private TowerContractFinalSettleLostService towerContractFinalSettleLostService;

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("分页查询结算书缺失物品")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerContractFinalSettleLost>> page(TowerContractFinalSettleLostParam param) {
        PageParam<TowerContractFinalSettleLost, TowerContractFinalSettleLostParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerContractFinalSettleLostService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(towerContractFinalSettleLostService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("查询全部结算书缺失物品")
    @GetMapping()
    public ApiResult<List<TowerContractFinalSettleLost>> list(TowerContractFinalSettleLostParam param) {
        PageParam<TowerContractFinalSettleLost, TowerContractFinalSettleLostParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerContractFinalSettleLostService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(towerContractFinalSettleLostService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("根据id查询结算书缺失物品")
    @GetMapping("/{id}")
    public ApiResult<TowerContractFinalSettleLost> get(@PathVariable("id") Integer id) {
        return success(towerContractFinalSettleLostService.getById(id));
        // 使用关联查询
        //return success(towerContractFinalSettleLostService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:save')")
    @OperationLog
    @ApiOperation("添加结算书缺失物品")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerContractFinalSettleLost towerContractFinalSettleLost) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerContractFinalSettleLost.setUserId(loginUser.getUserId());
        }
        if (towerContractFinalSettleLostService.save(towerContractFinalSettleLost)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:update')")
    @OperationLog
    @ApiOperation("修改结算书缺失物品")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerContractFinalSettleLost towerContractFinalSettleLost) {
        if (towerContractFinalSettleLostService.updateById(towerContractFinalSettleLost)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:remove')")
    @OperationLog
    @ApiOperation("删除结算书缺失物品")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerContractFinalSettleLostService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:save')")
    @OperationLog
    @ApiOperation("批量添加结算书缺失物品")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerContractFinalSettleLost> list) {
        if (towerContractFinalSettleLostService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:update')")
    @OperationLog
    @ApiOperation("批量修改结算书缺失物品")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerContractFinalSettleLost> batchParam) {
        if (batchParam.update(towerContractFinalSettleLostService, "final_settle_lost_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:remove')")
    @OperationLog
    @ApiOperation("批量删除结算书缺失物品")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerContractFinalSettleLostService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
